/*
 * Copyright (C) 2015 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


package org.thema.mupcity;

import com.thoughtworks.xstream.XStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;

/**
 * Dialog form for project creation.
 * 
 * @author  Gilles Vuidel
 */
public class NewProjectDialog extends javax.swing.JDialog {
    
    private Project project;
    
    /** Creates new form newProjectDialog */
    public NewProjectDialog(java.awt.Frame parent) {
        super(parent, true);
        initComponents();
        setLocationRelativeTo(parent);
    }

    /**
     * @return the created project or null
     */
    public Project getProject() {
        return project;
    }
    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        createButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        zonePrjSelectFilePanel = new org.thema.common.swing.SelectFilePanel();
        jLabel1 = new javax.swing.JLabel();
        buildSelectFilePane = new org.thema.common.swing.SelectFilePanel();
        jLabel2 = new javax.swing.JLabel();
        nameTextField = new javax.swing.JTextField();
        dirSelectFilePanel = new org.thema.common.swing.SelectFilePanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/thema/mupcity/Bundle"); // NOI18N
        setTitle(bundle.getString("NewProjectDialog.title")); // NOI18N

        createButton.setText(bundle.getString("NewProjectDialog.createButton.text")); // NOI18N
        createButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                createButtonActionPerformed(evt);
            }
        });

        cancelButton.setText(bundle.getString("NewProjectDialog.cancelButton.text")); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        zonePrjSelectFilePanel.setDescription(bundle.getString("NewProjectDialog.zonePrjSelectFilePanel.description")); // NOI18N
        zonePrjSelectFilePanel.setFileDesc(bundle.getString("NewProjectDialog.zonePrjSelectFilePanel.fileDesc")); // NOI18N
        zonePrjSelectFilePanel.setFileExts(bundle.getString("NewProjectDialog.zonePrjSelectFilePanel.fileExts")); // NOI18N

        jLabel1.setText(bundle.getString("NewProjectDialog.jLabel1.text")); // NOI18N

        buildSelectFilePane.setDescription(bundle.getString("NewProjectDialog.buildSelectFilePane.description")); // NOI18N
        buildSelectFilePane.setFileDesc(bundle.getString("NewProjectDialog.buildSelectFilePane.fileDesc")); // NOI18N
        buildSelectFilePane.setFileExts(bundle.getString("NewProjectDialog.buildSelectFilePane.fileExts")); // NOI18N

        jLabel2.setText(bundle.getString("NewProjectDialog.jLabel2.text")); // NOI18N

        nameTextField.setText(bundle.getString("NewProjectDialog.nameTextField.text")); // NOI18N

        dirSelectFilePanel.setDescription(bundle.getString("NewProjectDialog.dirSelectFilePanel.description")); // NOI18N
        dirSelectFilePanel.setDirectoryOnly(true);
        dirSelectFilePanel.setFileDesc(bundle.getString("NewProjectDialog.dirSelectFilePanel.fileDesc")); // NOI18N
        dirSelectFilePanel.setFileExts(bundle.getString("NewProjectDialog.dirSelectFilePanel.fileExts")); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(createButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(cancelButton))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(zonePrjSelectFilePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 542, Short.MAX_VALUE)
                            .addComponent(buildSelectFilePane, javax.swing.GroupLayout.DEFAULT_SIZE, 542, Short.MAX_VALUE)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel1)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jLabel2)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(nameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 181, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                .addGap(0, 0, Short.MAX_VALUE))
                            .addComponent(dirSelectFilePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 542, Short.MAX_VALUE))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(nameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(dirSelectFilePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 11, Short.MAX_VALUE)
                .addComponent(buildSelectFilePane, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(zonePrjSelectFilePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel1)
                .addGap(9, 9, 9)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cancelButton)
                    .addComponent(createButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void createButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createButtonActionPerformed
        Project zonePrj = null;
        if(zonePrjSelectFilePanel.getSelectedFile() != null) {
            XStream xml = new XStream();
            try (FileReader fr = new FileReader(zonePrjSelectFilePanel.getSelectedFile())) {
                zonePrj = (Project)xml.fromXML(fr);
            } catch (IOException e) {
                Logger.getLogger(NewProjectDialog.class.getName()).log(Level.SEVERE, null, e);
                JOptionPane.showMessageDialog(null, "Impossible de lire le projet pour la zone!\nDétails : " + e, "Erreur", JOptionPane.ERROR_MESSAGE);      
                return;
            }
        }

        try {
            project = Project.createProject(nameTextField.getText(), dirSelectFilePanel.getSelectedFile(), buildSelectFilePane.getSelectedFile(), null);
            if(zonePrj != null) {
                project.setBounds(zonePrj);
            }
        } catch(IOException ex) {
            Logger.getLogger(NewProjectDialog.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, "An error occured while creating project :\n" + ex.getLocalizedMessage());
            return;
        }
        
        setVisible(false);
        dispose();
    }//GEN-LAST:event_createButtonActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.thema.common.swing.SelectFilePanel buildSelectFilePane;
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton createButton;
    private org.thema.common.swing.SelectFilePanel dirSelectFilePanel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JTextField nameTextField;
    private org.thema.common.swing.SelectFilePanel zonePrjSelectFilePanel;
    // End of variables declaration//GEN-END:variables
    
}
